// components/cast_streaming/public/mojom/cast_streaming_session.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_CAST_STREAMING_SESSION_MOJOM_H_
#define COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_CAST_STREAMING_SESSION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/cast_streaming/public/mojom/cast_streaming_session.mojom-shared.h"
#include "components/cast_streaming/public/mojom/cast_streaming_session.mojom-forward.h"
#include "media/mojo/mojom/media_types.mojom.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"




namespace cast_streaming {
namespace mojom {

class AudioBufferRequesterProxy;

template <typename ImplRefTraits>
class AudioBufferRequesterStub;

class AudioBufferRequesterRequestValidator;
class AudioBufferRequesterResponseValidator;


class  AudioBufferRequester
    : public AudioBufferRequesterInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = AudioBufferRequesterInterfaceBase;
  using Proxy_ = AudioBufferRequesterProxy;

  template <typename ImplRefTraits>
  using Stub_ = AudioBufferRequesterStub<ImplRefTraits>;

  using RequestValidator_ = AudioBufferRequesterRequestValidator;
  using ResponseValidator_ = AudioBufferRequesterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetBufferMinVersion = 0,
  };
  virtual ~AudioBufferRequester() = default;


  using GetBufferCallback = base::OnceCallback<void(AudioStreamInfoPtr, ::media::mojom::DecoderBufferPtr)>;
  
  virtual void GetBuffer(GetBufferCallback callback) = 0;
};

class VideoBufferRequesterProxy;

template <typename ImplRefTraits>
class VideoBufferRequesterStub;

class VideoBufferRequesterRequestValidator;
class VideoBufferRequesterResponseValidator;


class  VideoBufferRequester
    : public VideoBufferRequesterInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = VideoBufferRequesterInterfaceBase;
  using Proxy_ = VideoBufferRequesterProxy;

  template <typename ImplRefTraits>
  using Stub_ = VideoBufferRequesterStub<ImplRefTraits>;

  using RequestValidator_ = VideoBufferRequesterRequestValidator;
  using ResponseValidator_ = VideoBufferRequesterResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetBufferMinVersion = 0,
  };
  virtual ~VideoBufferRequester() = default;


  using GetBufferCallback = base::OnceCallback<void(VideoStreamInfoPtr, ::media::mojom::DecoderBufferPtr)>;
  
  virtual void GetBuffer(GetBufferCallback callback) = 0;
};

class CastStreamingReceiverProxy;

template <typename ImplRefTraits>
class CastStreamingReceiverStub;

class CastStreamingReceiverRequestValidator;
class CastStreamingReceiverResponseValidator;


class  CastStreamingReceiver
    : public CastStreamingReceiverInterfaceBase {
 public:
  static const char Name_[];
  static uint32_t MessageToStableIPCHash_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = CastStreamingReceiverInterfaceBase;
  using Proxy_ = CastStreamingReceiverProxy;

  template <typename ImplRefTraits>
  using Stub_ = CastStreamingReceiverStub<ImplRefTraits>;

  using RequestValidator_ = CastStreamingReceiverRequestValidator;
  using ResponseValidator_ = CastStreamingReceiverResponseValidator;
  enum MethodMinVersions : uint32_t {
    kEnableReceiverMinVersion = 0,
    kOnStreamsInitializedMinVersion = 0,
  };
  virtual ~CastStreamingReceiver() = default;


  using EnableReceiverCallback = base::OnceCallback<void()>;
  
  virtual void EnableReceiver(EnableReceiverCallback callback) = 0;

  
  virtual void OnStreamsInitialized(AudioStreamInitializationInfoPtr audio_buffer_requester, VideoStreamInitializationInfoPtr video_buffer_requester) = 0;
};



class  AudioBufferRequesterProxy
    : public AudioBufferRequester {
 public:
  using InterfaceType = AudioBufferRequester;

  explicit AudioBufferRequesterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetBuffer(GetBufferCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  VideoBufferRequesterProxy
    : public VideoBufferRequester {
 public:
  using InterfaceType = VideoBufferRequester;

  explicit VideoBufferRequesterProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetBuffer(GetBufferCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class  CastStreamingReceiverProxy
    : public CastStreamingReceiver {
 public:
  using InterfaceType = CastStreamingReceiver;

  explicit CastStreamingReceiverProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void EnableReceiver(EnableReceiverCallback callback) final;
  
  void OnStreamsInitialized(AudioStreamInitializationInfoPtr audio_buffer_requester, VideoStreamInitializationInfoPtr video_buffer_requester) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  AudioBufferRequesterStubDispatch {
 public:
  static bool Accept(AudioBufferRequester* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      AudioBufferRequester* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<AudioBufferRequester>>
class AudioBufferRequesterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  AudioBufferRequesterStub() = default;
  ~AudioBufferRequesterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AudioBufferRequesterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return AudioBufferRequesterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  VideoBufferRequesterStubDispatch {
 public:
  static bool Accept(VideoBufferRequester* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      VideoBufferRequester* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<VideoBufferRequester>>
class VideoBufferRequesterStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  VideoBufferRequesterStub() = default;
  ~VideoBufferRequesterStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VideoBufferRequesterStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return VideoBufferRequesterStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  CastStreamingReceiverStubDispatch {
 public:
  static bool Accept(CastStreamingReceiver* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      CastStreamingReceiver* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<CastStreamingReceiver>>
class CastStreamingReceiverStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  CastStreamingReceiverStub() = default;
  ~CastStreamingReceiverStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CastStreamingReceiverStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return CastStreamingReceiverStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  AudioBufferRequesterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  VideoBufferRequesterRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  CastStreamingReceiverRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  AudioBufferRequesterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  VideoBufferRequesterResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  CastStreamingReceiverResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};











class  AudioStreamInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AudioStreamInfo, T>::value>;
  using DataView = AudioStreamInfoDataView;
  using Data_ = internal::AudioStreamInfo_Data;

  template <typename... Args>
  static AudioStreamInfoPtr New(Args&&... args) {
    return AudioStreamInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AudioStreamInfoPtr From(const U& u) {
    return mojo::TypeConverter<AudioStreamInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AudioStreamInfo>::Convert(*this);
  }


  AudioStreamInfo();

  AudioStreamInfo(
      const ::media::AudioDecoderConfig& decoder_config,
      ::mojo::ScopedDataPipeConsumerHandle data_pipe);

AudioStreamInfo(const AudioStreamInfo&) = delete;
AudioStreamInfo& operator=(const AudioStreamInfo&) = delete;

  ~AudioStreamInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AudioStreamInfoPtr>
  AudioStreamInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AudioStreamInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AudioStreamInfo_UnserializedMessageContext<
            UserType, AudioStreamInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AudioStreamInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AudioStreamInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AudioStreamInfo_UnserializedMessageContext<
            UserType, AudioStreamInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AudioStreamInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::media::AudioDecoderConfig decoder_config;
  
  ::mojo::ScopedDataPipeConsumerHandle data_pipe;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AudioStreamInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  VideoStreamInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<VideoStreamInfo, T>::value>;
  using DataView = VideoStreamInfoDataView;
  using Data_ = internal::VideoStreamInfo_Data;

  template <typename... Args>
  static VideoStreamInfoPtr New(Args&&... args) {
    return VideoStreamInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static VideoStreamInfoPtr From(const U& u) {
    return mojo::TypeConverter<VideoStreamInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VideoStreamInfo>::Convert(*this);
  }


  VideoStreamInfo();

  VideoStreamInfo(
      const ::media::VideoDecoderConfig& decoder_config,
      ::mojo::ScopedDataPipeConsumerHandle data_pipe);

VideoStreamInfo(const VideoStreamInfo&) = delete;
VideoStreamInfo& operator=(const VideoStreamInfo&) = delete;

  ~VideoStreamInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VideoStreamInfoPtr>
  VideoStreamInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VideoStreamInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VideoStreamInfo_UnserializedMessageContext<
            UserType, VideoStreamInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<VideoStreamInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VideoStreamInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VideoStreamInfo_UnserializedMessageContext<
            UserType, VideoStreamInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VideoStreamInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::media::VideoDecoderConfig decoder_config;
  
  ::mojo::ScopedDataPipeConsumerHandle data_pipe;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, VideoStreamInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  AudioStreamInitializationInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<AudioStreamInitializationInfo, T>::value>;
  using DataView = AudioStreamInitializationInfoDataView;
  using Data_ = internal::AudioStreamInitializationInfo_Data;

  template <typename... Args>
  static AudioStreamInitializationInfoPtr New(Args&&... args) {
    return AudioStreamInitializationInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static AudioStreamInitializationInfoPtr From(const U& u) {
    return mojo::TypeConverter<AudioStreamInitializationInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, AudioStreamInitializationInfo>::Convert(*this);
  }


  AudioStreamInitializationInfo();

  AudioStreamInitializationInfo(
      ::mojo::PendingRemote<AudioBufferRequester> buffer_requester,
      AudioStreamInfoPtr stream_initialization_info);

AudioStreamInitializationInfo(const AudioStreamInitializationInfo&) = delete;
AudioStreamInitializationInfo& operator=(const AudioStreamInitializationInfo&) = delete;

  ~AudioStreamInitializationInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = AudioStreamInitializationInfoPtr>
  AudioStreamInitializationInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        AudioStreamInitializationInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::AudioStreamInitializationInfo_UnserializedMessageContext<
            UserType, AudioStreamInitializationInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<AudioStreamInitializationInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return AudioStreamInitializationInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::AudioStreamInitializationInfo_UnserializedMessageContext<
            UserType, AudioStreamInitializationInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<AudioStreamInitializationInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::mojo::PendingRemote<AudioBufferRequester> buffer_requester;
  
  AudioStreamInfoPtr stream_initialization_info;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  VideoStreamInitializationInfo {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<VideoStreamInitializationInfo, T>::value>;
  using DataView = VideoStreamInitializationInfoDataView;
  using Data_ = internal::VideoStreamInitializationInfo_Data;

  template <typename... Args>
  static VideoStreamInitializationInfoPtr New(Args&&... args) {
    return VideoStreamInitializationInfoPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static VideoStreamInitializationInfoPtr From(const U& u) {
    return mojo::TypeConverter<VideoStreamInitializationInfoPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, VideoStreamInitializationInfo>::Convert(*this);
  }


  VideoStreamInitializationInfo();

  VideoStreamInitializationInfo(
      ::mojo::PendingRemote<VideoBufferRequester> buffer_requester,
      VideoStreamInfoPtr stream_initialization_info);

VideoStreamInitializationInfo(const VideoStreamInitializationInfo&) = delete;
VideoStreamInitializationInfo& operator=(const VideoStreamInitializationInfo&) = delete;

  ~VideoStreamInitializationInfo();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = VideoStreamInitializationInfoPtr>
  VideoStreamInitializationInfoPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        VideoStreamInitializationInfo::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::VideoStreamInitializationInfo_UnserializedMessageContext<
            UserType, VideoStreamInitializationInfo::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<VideoStreamInitializationInfo::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return VideoStreamInitializationInfo::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::VideoStreamInitializationInfo_UnserializedMessageContext<
            UserType, VideoStreamInitializationInfo::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<VideoStreamInitializationInfo::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::mojo::PendingRemote<VideoBufferRequester> buffer_requester;
  
  VideoStreamInfoPtr stream_initialization_info;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
AudioStreamInfoPtr AudioStreamInfo::Clone() const {
  return New(
      mojo::Clone(decoder_config),
      mojo::Clone(data_pipe)
  );
}

template <typename T, AudioStreamInfo::EnableIfSame<T>*>
bool AudioStreamInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->decoder_config, other_struct.decoder_config))
    return false;
  if (!mojo::Equals(this->data_pipe, other_struct.data_pipe))
    return false;
  return true;
}

template <typename T, AudioStreamInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.decoder_config < rhs.decoder_config)
    return true;
  if (rhs.decoder_config < lhs.decoder_config)
    return false;
  if (lhs.data_pipe < rhs.data_pipe)
    return true;
  if (rhs.data_pipe < lhs.data_pipe)
    return false;
  return false;
}
template <typename StructPtrType>
VideoStreamInfoPtr VideoStreamInfo::Clone() const {
  return New(
      mojo::Clone(decoder_config),
      mojo::Clone(data_pipe)
  );
}

template <typename T, VideoStreamInfo::EnableIfSame<T>*>
bool VideoStreamInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->decoder_config, other_struct.decoder_config))
    return false;
  if (!mojo::Equals(this->data_pipe, other_struct.data_pipe))
    return false;
  return true;
}

template <typename T, VideoStreamInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.decoder_config < rhs.decoder_config)
    return true;
  if (rhs.decoder_config < lhs.decoder_config)
    return false;
  if (lhs.data_pipe < rhs.data_pipe)
    return true;
  if (rhs.data_pipe < lhs.data_pipe)
    return false;
  return false;
}
template <typename StructPtrType>
AudioStreamInitializationInfoPtr AudioStreamInitializationInfo::Clone() const {
  return New(
      mojo::Clone(buffer_requester),
      mojo::Clone(stream_initialization_info)
  );
}

template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>*>
bool AudioStreamInitializationInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->buffer_requester, other_struct.buffer_requester))
    return false;
  if (!mojo::Equals(this->stream_initialization_info, other_struct.stream_initialization_info))
    return false;
  return true;
}

template <typename T, AudioStreamInitializationInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.buffer_requester < rhs.buffer_requester)
    return true;
  if (rhs.buffer_requester < lhs.buffer_requester)
    return false;
  if (lhs.stream_initialization_info < rhs.stream_initialization_info)
    return true;
  if (rhs.stream_initialization_info < lhs.stream_initialization_info)
    return false;
  return false;
}
template <typename StructPtrType>
VideoStreamInitializationInfoPtr VideoStreamInitializationInfo::Clone() const {
  return New(
      mojo::Clone(buffer_requester),
      mojo::Clone(stream_initialization_info)
  );
}

template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>*>
bool VideoStreamInitializationInfo::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->buffer_requester, other_struct.buffer_requester))
    return false;
  if (!mojo::Equals(this->stream_initialization_info, other_struct.stream_initialization_info))
    return false;
  return true;
}

template <typename T, VideoStreamInitializationInfo::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.buffer_requester < rhs.buffer_requester)
    return true;
  if (rhs.buffer_requester < lhs.buffer_requester)
    return false;
  if (lhs.stream_initialization_info < rhs.stream_initialization_info)
    return true;
  if (rhs.stream_initialization_info < lhs.stream_initialization_info)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace cast_streaming

namespace mojo {


template <>
struct  StructTraits<::cast_streaming::mojom::AudioStreamInfo::DataView,
                                         ::cast_streaming::mojom::AudioStreamInfoPtr> {
  static bool IsNull(const ::cast_streaming::mojom::AudioStreamInfoPtr& input) { return !input; }
  static void SetToNull(::cast_streaming::mojom::AudioStreamInfoPtr* output) { output->reset(); }

  static const decltype(::cast_streaming::mojom::AudioStreamInfo::decoder_config)& decoder_config(
      const ::cast_streaming::mojom::AudioStreamInfoPtr& input) {
    return input->decoder_config;
  }

  static  decltype(::cast_streaming::mojom::AudioStreamInfo::data_pipe)& data_pipe(
       ::cast_streaming::mojom::AudioStreamInfoPtr& input) {
    return input->data_pipe;
  }

  static bool Read(::cast_streaming::mojom::AudioStreamInfo::DataView input, ::cast_streaming::mojom::AudioStreamInfoPtr* output);
};


template <>
struct  StructTraits<::cast_streaming::mojom::VideoStreamInfo::DataView,
                                         ::cast_streaming::mojom::VideoStreamInfoPtr> {
  static bool IsNull(const ::cast_streaming::mojom::VideoStreamInfoPtr& input) { return !input; }
  static void SetToNull(::cast_streaming::mojom::VideoStreamInfoPtr* output) { output->reset(); }

  static const decltype(::cast_streaming::mojom::VideoStreamInfo::decoder_config)& decoder_config(
      const ::cast_streaming::mojom::VideoStreamInfoPtr& input) {
    return input->decoder_config;
  }

  static  decltype(::cast_streaming::mojom::VideoStreamInfo::data_pipe)& data_pipe(
       ::cast_streaming::mojom::VideoStreamInfoPtr& input) {
    return input->data_pipe;
  }

  static bool Read(::cast_streaming::mojom::VideoStreamInfo::DataView input, ::cast_streaming::mojom::VideoStreamInfoPtr* output);
};


template <>
struct  StructTraits<::cast_streaming::mojom::AudioStreamInitializationInfo::DataView,
                                         ::cast_streaming::mojom::AudioStreamInitializationInfoPtr> {
  static bool IsNull(const ::cast_streaming::mojom::AudioStreamInitializationInfoPtr& input) { return !input; }
  static void SetToNull(::cast_streaming::mojom::AudioStreamInitializationInfoPtr* output) { output->reset(); }

  static  decltype(::cast_streaming::mojom::AudioStreamInitializationInfo::buffer_requester)& buffer_requester(
       ::cast_streaming::mojom::AudioStreamInitializationInfoPtr& input) {
    return input->buffer_requester;
  }

  static  decltype(::cast_streaming::mojom::AudioStreamInitializationInfo::stream_initialization_info)& stream_initialization_info(
       ::cast_streaming::mojom::AudioStreamInitializationInfoPtr& input) {
    return input->stream_initialization_info;
  }

  static bool Read(::cast_streaming::mojom::AudioStreamInitializationInfo::DataView input, ::cast_streaming::mojom::AudioStreamInitializationInfoPtr* output);
};


template <>
struct  StructTraits<::cast_streaming::mojom::VideoStreamInitializationInfo::DataView,
                                         ::cast_streaming::mojom::VideoStreamInitializationInfoPtr> {
  static bool IsNull(const ::cast_streaming::mojom::VideoStreamInitializationInfoPtr& input) { return !input; }
  static void SetToNull(::cast_streaming::mojom::VideoStreamInitializationInfoPtr* output) { output->reset(); }

  static  decltype(::cast_streaming::mojom::VideoStreamInitializationInfo::buffer_requester)& buffer_requester(
       ::cast_streaming::mojom::VideoStreamInitializationInfoPtr& input) {
    return input->buffer_requester;
  }

  static  decltype(::cast_streaming::mojom::VideoStreamInitializationInfo::stream_initialization_info)& stream_initialization_info(
       ::cast_streaming::mojom::VideoStreamInitializationInfoPtr& input) {
    return input->stream_initialization_info;
  }

  static bool Read(::cast_streaming::mojom::VideoStreamInitializationInfo::DataView input, ::cast_streaming::mojom::VideoStreamInitializationInfoPtr* output);
};

}  // namespace mojo

#endif  // COMPONENTS_CAST_STREAMING_PUBLIC_MOJOM_CAST_STREAMING_SESSION_MOJOM_H_