// extensions/common/mojom/activation_sequence.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef EXTENSIONS_COMMON_MOJOM_ACTIVATION_SEQUENCE_MOJOM_H_
#define EXTENSIONS_COMMON_MOJOM_ACTIVATION_SEQUENCE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "extensions/common/mojom/activation_sequence.mojom-shared.h"
#include "extensions/common/mojom/activation_sequence.mojom-forward.h"
#include <string>
#include <vector>




#include "extensions/common/mojom/activation_sequence_mojom_traits.h"




namespace extensions {
namespace mojom {





class  ActivationSequence {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ActivationSequence, T>::value>;
  using DataView = ActivationSequenceDataView;
  using Data_ = internal::ActivationSequence_Data;

  template <typename... Args>
  static ActivationSequencePtr New(Args&&... args) {
    return ActivationSequencePtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ActivationSequencePtr From(const U& u) {
    return mojo::TypeConverter<ActivationSequencePtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ActivationSequence>::Convert(*this);
  }


  ActivationSequence();

  explicit ActivationSequence(
      int32_t value);


  ~ActivationSequence();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ActivationSequencePtr>
  ActivationSequencePtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        ActivationSequence::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ActivationSequence::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ActivationSequence_UnserializedMessageContext<
            UserType, ActivationSequence::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ActivationSequence::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ActivationSequence::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ActivationSequence_UnserializedMessageContext<
            UserType, ActivationSequence::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ActivationSequence::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  int32_t value;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ActivationSequence::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}




template <typename StructPtrType>
ActivationSequencePtr ActivationSequence::Clone() const {
  return New(
      mojo::Clone(value)
  );
}

template <typename T, ActivationSequence::EnableIfSame<T>*>
bool ActivationSequence::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->value, other_struct.value))
    return false;
  return true;
}

template <typename T, ActivationSequence::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.value < rhs.value)
    return true;
  if (rhs.value < lhs.value)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace extensions

namespace mojo {


template <>
struct  StructTraits<::extensions::mojom::ActivationSequence::DataView,
                                         ::extensions::mojom::ActivationSequencePtr> {
  static bool IsNull(const ::extensions::mojom::ActivationSequencePtr& input) { return !input; }
  static void SetToNull(::extensions::mojom::ActivationSequencePtr* output) { output->reset(); }

  static decltype(::extensions::mojom::ActivationSequence::value) value(
      const ::extensions::mojom::ActivationSequencePtr& input) {
    return input->value;
  }

  static bool Read(::extensions::mojom::ActivationSequence::DataView input, ::extensions::mojom::ActivationSequencePtr* output);
};

}  // namespace mojo

#endif  // EXTENSIONS_COMMON_MOJOM_ACTIVATION_SEQUENCE_MOJOM_H_