// media/mojo/mojom/renderer_extensions.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "media/mojo/mojom/renderer_extensions.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "media/mojo/mojom/renderer_extensions.mojom-params-data.h"
namespace media {
namespace mojom {

static NOINLINE const char* RenderingModeToStringHelper(RenderingMode value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case RenderingMode::DirectComposition:
      return "DirectComposition";
    case RenderingMode::FrameServer:
      return "FrameServer";
    default:
      return nullptr;
  }
}

std::string RenderingModeToString(RenderingMode value) {
  const char *str = RenderingModeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown RenderingMode value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, RenderingMode value) {
  return os << RenderingModeToString(value);
}

namespace internal {


// static
bool MediaPlayerRendererClientExtension_OnVideoSizeChange_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const MediaPlayerRendererClientExtension_OnVideoSizeChange_Params_Data* object =
      static_cast<const MediaPlayerRendererClientExtension_OnVideoSizeChange_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->size, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->size, validation_context))
    return false;

  return true;
}

MediaPlayerRendererClientExtension_OnVideoSizeChange_Params_Data::MediaPlayerRendererClientExtension_OnVideoSizeChange_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool MediaPlayerRendererClientExtension_OnDurationChange_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const MediaPlayerRendererClientExtension_OnDurationChange_Params_Data* object =
      static_cast<const MediaPlayerRendererClientExtension_OnDurationChange_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->duration, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->duration, validation_context))
    return false;

  return true;
}

MediaPlayerRendererClientExtension_OnDurationChange_Params_Data::MediaPlayerRendererClientExtension_OnDurationChange_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_Params_Data* object =
      static_cast<const MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_Params_Data*>(data);

  return true;
}

MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_Params_Data::MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_ResponseParams_Data* object =
      static_cast<const MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->request_token, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->request_token, validation_context))
    return false;

  return true;
}

MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_ResponseParams_Data::MediaPlayerRendererExtension_InitiateScopedSurfaceRequest_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool FlingingRendererClientExtension_OnRemotePlayStateChange_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const FlingingRendererClientExtension_OnRemotePlayStateChange_Params_Data* object =
      static_cast<const FlingingRendererClientExtension_OnRemotePlayStateChange_Params_Data*>(data);


  if (!::media::mojom::internal::MediaStatusState_Data
        ::Validate(object->state, validation_context))
    return false;

  return true;
}

FlingingRendererClientExtension_OnRemotePlayStateChange_Params_Data::FlingingRendererClientExtension_OnRemotePlayStateChange_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace media

namespace perfetto {

// static
void TraceFormatTraits<::media::mojom::RenderingMode>::WriteIntoTrace(
   perfetto::TracedValue context, ::media::mojom::RenderingMode value) {
  return std::move(context).WriteString(::media::mojom::RenderingModeToString(value));
}

} // namespace perfetto