// media/mojo/mojom/speech_recognition_service.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_
#define MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_

#include "media/mojo/mojom/speech_recognition_service.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace media {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT SpeechRecognitionContextInterceptorForTesting : public SpeechRecognitionContext {
  virtual SpeechRecognitionContext* GetForwardingInterface() = 0;
  void BindRecognizer(::mojo::PendingReceiver<SpeechRecognitionRecognizer> receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, BindRecognizerCallback callback) override;
  void BindAudioSourceFetcher(::mojo::PendingReceiver<AudioSourceFetcher> fetcher_receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, BindAudioSourceFetcherCallback callback) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionContextAsyncWaiter {
 public:
  explicit SpeechRecognitionContextAsyncWaiter(SpeechRecognitionContext* proxy);

  SpeechRecognitionContextAsyncWaiter(const SpeechRecognitionContextAsyncWaiter&) = delete;
  SpeechRecognitionContextAsyncWaiter& operator=(const SpeechRecognitionContextAsyncWaiter&) = delete;

  ~SpeechRecognitionContextAsyncWaiter();
  void BindRecognizer(
      ::mojo::PendingReceiver<SpeechRecognitionRecognizer> receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, bool* out_is_multichannel_supported);
  void BindAudioSourceFetcher(
      ::mojo::PendingReceiver<AudioSourceFetcher> fetcher_receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, bool* out_is_multichannel_supported);

 private:
  SpeechRecognitionContext* const proxy_;
};


class BLINK_PLATFORM_EXPORT SpeechRecognitionServiceInterceptorForTesting : public SpeechRecognitionService {
  virtual SpeechRecognitionService* GetForwardingInterface() = 0;
  void BindContext(::mojo::PendingReceiver<SpeechRecognitionContext> context) override;
  void SetSodaPath(const ::base::FilePath& binary_path, const ::base::FilePath& config_path) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionServiceAsyncWaiter {
 public:
  explicit SpeechRecognitionServiceAsyncWaiter(SpeechRecognitionService* proxy);

  SpeechRecognitionServiceAsyncWaiter(const SpeechRecognitionServiceAsyncWaiter&) = delete;
  SpeechRecognitionServiceAsyncWaiter& operator=(const SpeechRecognitionServiceAsyncWaiter&) = delete;

  ~SpeechRecognitionServiceAsyncWaiter();

 private:
  SpeechRecognitionService* const proxy_;
};


class BLINK_PLATFORM_EXPORT AudioSourceFetcherInterceptorForTesting : public AudioSourceFetcher {
  virtual AudioSourceFetcher* GetForwardingInterface() = 0;
  void Start(::mojo::PendingRemote<::media::mojom::blink::AudioStreamFactory> factory, const WTF::String& device_id, const ::media::AudioParameters& audio_parameters) override;
  void Stop() override;
};
class BLINK_PLATFORM_EXPORT AudioSourceFetcherAsyncWaiter {
 public:
  explicit AudioSourceFetcherAsyncWaiter(AudioSourceFetcher* proxy);

  AudioSourceFetcherAsyncWaiter(const AudioSourceFetcherAsyncWaiter&) = delete;
  AudioSourceFetcherAsyncWaiter& operator=(const AudioSourceFetcherAsyncWaiter&) = delete;

  ~AudioSourceFetcherAsyncWaiter();

 private:
  AudioSourceFetcher* const proxy_;
};


class BLINK_PLATFORM_EXPORT SpeechRecognitionRecognizerInterceptorForTesting : public SpeechRecognitionRecognizer {
  virtual SpeechRecognitionRecognizer* GetForwardingInterface() = 0;
  void SendAudioToSpeechRecognitionService(::media::mojom::blink::AudioDataS16Ptr buffer) override;
  void MarkDone() override;
  void OnLanguageChanged(const WTF::String& language) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionRecognizerAsyncWaiter {
 public:
  explicit SpeechRecognitionRecognizerAsyncWaiter(SpeechRecognitionRecognizer* proxy);

  SpeechRecognitionRecognizerAsyncWaiter(const SpeechRecognitionRecognizerAsyncWaiter&) = delete;
  SpeechRecognitionRecognizerAsyncWaiter& operator=(const SpeechRecognitionRecognizerAsyncWaiter&) = delete;

  ~SpeechRecognitionRecognizerAsyncWaiter();

 private:
  SpeechRecognitionRecognizer* const proxy_;
};


class BLINK_PLATFORM_EXPORT SpeechRecognitionRecognizerClientInterceptorForTesting : public SpeechRecognitionRecognizerClient {
  virtual SpeechRecognitionRecognizerClient* GetForwardingInterface() = 0;
  void OnSpeechRecognitionRecognitionEvent(SpeechRecognitionResultPtr result, OnSpeechRecognitionRecognitionEventCallback callback) override;
  void OnSpeechRecognitionStopped() override;
  void OnSpeechRecognitionError() override;
  void OnLanguageIdentificationEvent(LanguageIdentificationEventPtr event) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionRecognizerClientAsyncWaiter {
 public:
  explicit SpeechRecognitionRecognizerClientAsyncWaiter(SpeechRecognitionRecognizerClient* proxy);

  SpeechRecognitionRecognizerClientAsyncWaiter(const SpeechRecognitionRecognizerClientAsyncWaiter&) = delete;
  SpeechRecognitionRecognizerClientAsyncWaiter& operator=(const SpeechRecognitionRecognizerClientAsyncWaiter&) = delete;

  ~SpeechRecognitionRecognizerClientAsyncWaiter();
  void OnSpeechRecognitionRecognitionEvent(
      SpeechRecognitionResultPtr result, bool* out_success);

 private:
  SpeechRecognitionRecognizerClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT SpeechRecognitionBrowserObserverInterceptorForTesting : public SpeechRecognitionBrowserObserver {
  virtual SpeechRecognitionBrowserObserver* GetForwardingInterface() = 0;
  void SpeechRecognitionAvailabilityChanged(bool is_speech_recognition_available) override;
  void SpeechRecognitionLanguageChanged(const WTF::String& language) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionBrowserObserverAsyncWaiter {
 public:
  explicit SpeechRecognitionBrowserObserverAsyncWaiter(SpeechRecognitionBrowserObserver* proxy);

  SpeechRecognitionBrowserObserverAsyncWaiter(const SpeechRecognitionBrowserObserverAsyncWaiter&) = delete;
  SpeechRecognitionBrowserObserverAsyncWaiter& operator=(const SpeechRecognitionBrowserObserverAsyncWaiter&) = delete;

  ~SpeechRecognitionBrowserObserverAsyncWaiter();

 private:
  SpeechRecognitionBrowserObserver* const proxy_;
};


class BLINK_PLATFORM_EXPORT SpeechRecognitionClientBrowserInterfaceInterceptorForTesting : public SpeechRecognitionClientBrowserInterface {
  virtual SpeechRecognitionClientBrowserInterface* GetForwardingInterface() = 0;
  void BindSpeechRecognitionBrowserObserver(::mojo::PendingRemote<SpeechRecognitionBrowserObserver> observer) override;
};
class BLINK_PLATFORM_EXPORT SpeechRecognitionClientBrowserInterfaceAsyncWaiter {
 public:
  explicit SpeechRecognitionClientBrowserInterfaceAsyncWaiter(SpeechRecognitionClientBrowserInterface* proxy);

  SpeechRecognitionClientBrowserInterfaceAsyncWaiter(const SpeechRecognitionClientBrowserInterfaceAsyncWaiter&) = delete;
  SpeechRecognitionClientBrowserInterfaceAsyncWaiter& operator=(const SpeechRecognitionClientBrowserInterfaceAsyncWaiter&) = delete;

  ~SpeechRecognitionClientBrowserInterfaceAsyncWaiter();

 private:
  SpeechRecognitionClientBrowserInterface* const proxy_;
};


class BLINK_PLATFORM_EXPORT MediaFoundationRendererNotifierInterceptorForTesting : public MediaFoundationRendererNotifier {
  virtual MediaFoundationRendererNotifier* GetForwardingInterface() = 0;
  void MediaFoundationRendererCreated() override;
};
class BLINK_PLATFORM_EXPORT MediaFoundationRendererNotifierAsyncWaiter {
 public:
  explicit MediaFoundationRendererNotifierAsyncWaiter(MediaFoundationRendererNotifier* proxy);

  MediaFoundationRendererNotifierAsyncWaiter(const MediaFoundationRendererNotifierAsyncWaiter&) = delete;
  MediaFoundationRendererNotifierAsyncWaiter& operator=(const MediaFoundationRendererNotifierAsyncWaiter&) = delete;

  ~MediaFoundationRendererNotifierAsyncWaiter();

 private:
  MediaFoundationRendererNotifier* const proxy_;
};




}  // namespace blink
}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_BLINK_TEST_UTILS_H_