// media/mojo/mojom/speech_recognition_service.mojom-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_TEST_UTILS_H_
#define MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_TEST_UTILS_H_

#include "media/mojo/mojom/speech_recognition_service.mojom.h"


namespace media {
namespace mojom {


class  SpeechRecognitionContextInterceptorForTesting : public SpeechRecognitionContext {
  virtual SpeechRecognitionContext* GetForwardingInterface() = 0;
  void BindRecognizer(::mojo::PendingReceiver<SpeechRecognitionRecognizer> receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, BindRecognizerCallback callback) override;
  void BindAudioSourceFetcher(::mojo::PendingReceiver<AudioSourceFetcher> fetcher_receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, BindAudioSourceFetcherCallback callback) override;
};
class  SpeechRecognitionContextAsyncWaiter {
 public:
  explicit SpeechRecognitionContextAsyncWaiter(SpeechRecognitionContext* proxy);

  SpeechRecognitionContextAsyncWaiter(const SpeechRecognitionContextAsyncWaiter&) = delete;
  SpeechRecognitionContextAsyncWaiter& operator=(const SpeechRecognitionContextAsyncWaiter&) = delete;

  ~SpeechRecognitionContextAsyncWaiter();
  void BindRecognizer(
      ::mojo::PendingReceiver<SpeechRecognitionRecognizer> receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, bool* out_is_multichannel_supported);
  void BindAudioSourceFetcher(
      ::mojo::PendingReceiver<AudioSourceFetcher> fetcher_receiver, ::mojo::PendingRemote<SpeechRecognitionRecognizerClient> client, SpeechRecognitionOptionsPtr options, bool* out_is_multichannel_supported);

 private:
  SpeechRecognitionContext* const proxy_;
};


class  SpeechRecognitionServiceInterceptorForTesting : public SpeechRecognitionService {
  virtual SpeechRecognitionService* GetForwardingInterface() = 0;
  void BindContext(::mojo::PendingReceiver<SpeechRecognitionContext> context) override;
  void SetSodaPath(const ::base::FilePath& binary_path, const ::base::FilePath& config_path) override;
};
class  SpeechRecognitionServiceAsyncWaiter {
 public:
  explicit SpeechRecognitionServiceAsyncWaiter(SpeechRecognitionService* proxy);

  SpeechRecognitionServiceAsyncWaiter(const SpeechRecognitionServiceAsyncWaiter&) = delete;
  SpeechRecognitionServiceAsyncWaiter& operator=(const SpeechRecognitionServiceAsyncWaiter&) = delete;

  ~SpeechRecognitionServiceAsyncWaiter();

 private:
  SpeechRecognitionService* const proxy_;
};


class  AudioSourceFetcherInterceptorForTesting : public AudioSourceFetcher {
  virtual AudioSourceFetcher* GetForwardingInterface() = 0;
  void Start(::mojo::PendingRemote<::media::mojom::AudioStreamFactory> factory, const std::string& device_id, const ::media::AudioParameters& audio_parameters) override;
  void Stop() override;
};
class  AudioSourceFetcherAsyncWaiter {
 public:
  explicit AudioSourceFetcherAsyncWaiter(AudioSourceFetcher* proxy);

  AudioSourceFetcherAsyncWaiter(const AudioSourceFetcherAsyncWaiter&) = delete;
  AudioSourceFetcherAsyncWaiter& operator=(const AudioSourceFetcherAsyncWaiter&) = delete;

  ~AudioSourceFetcherAsyncWaiter();

 private:
  AudioSourceFetcher* const proxy_;
};


class  SpeechRecognitionRecognizerInterceptorForTesting : public SpeechRecognitionRecognizer {
  virtual SpeechRecognitionRecognizer* GetForwardingInterface() = 0;
  void SendAudioToSpeechRecognitionService(::media::mojom::AudioDataS16Ptr buffer) override;
  void MarkDone() override;
  void OnLanguageChanged(const std::string& language) override;
};
class  SpeechRecognitionRecognizerAsyncWaiter {
 public:
  explicit SpeechRecognitionRecognizerAsyncWaiter(SpeechRecognitionRecognizer* proxy);

  SpeechRecognitionRecognizerAsyncWaiter(const SpeechRecognitionRecognizerAsyncWaiter&) = delete;
  SpeechRecognitionRecognizerAsyncWaiter& operator=(const SpeechRecognitionRecognizerAsyncWaiter&) = delete;

  ~SpeechRecognitionRecognizerAsyncWaiter();

 private:
  SpeechRecognitionRecognizer* const proxy_;
};


class  SpeechRecognitionRecognizerClientInterceptorForTesting : public SpeechRecognitionRecognizerClient {
  virtual SpeechRecognitionRecognizerClient* GetForwardingInterface() = 0;
  void OnSpeechRecognitionRecognitionEvent(const ::media::SpeechRecognitionResult& result, OnSpeechRecognitionRecognitionEventCallback callback) override;
  void OnSpeechRecognitionStopped() override;
  void OnSpeechRecognitionError() override;
  void OnLanguageIdentificationEvent(LanguageIdentificationEventPtr event) override;
};
class  SpeechRecognitionRecognizerClientAsyncWaiter {
 public:
  explicit SpeechRecognitionRecognizerClientAsyncWaiter(SpeechRecognitionRecognizerClient* proxy);

  SpeechRecognitionRecognizerClientAsyncWaiter(const SpeechRecognitionRecognizerClientAsyncWaiter&) = delete;
  SpeechRecognitionRecognizerClientAsyncWaiter& operator=(const SpeechRecognitionRecognizerClientAsyncWaiter&) = delete;

  ~SpeechRecognitionRecognizerClientAsyncWaiter();
  void OnSpeechRecognitionRecognitionEvent(
      const ::media::SpeechRecognitionResult& result, bool* out_success);

 private:
  SpeechRecognitionRecognizerClient* const proxy_;
};


class  SpeechRecognitionBrowserObserverInterceptorForTesting : public SpeechRecognitionBrowserObserver {
  virtual SpeechRecognitionBrowserObserver* GetForwardingInterface() = 0;
  void SpeechRecognitionAvailabilityChanged(bool is_speech_recognition_available) override;
  void SpeechRecognitionLanguageChanged(const std::string& language) override;
};
class  SpeechRecognitionBrowserObserverAsyncWaiter {
 public:
  explicit SpeechRecognitionBrowserObserverAsyncWaiter(SpeechRecognitionBrowserObserver* proxy);

  SpeechRecognitionBrowserObserverAsyncWaiter(const SpeechRecognitionBrowserObserverAsyncWaiter&) = delete;
  SpeechRecognitionBrowserObserverAsyncWaiter& operator=(const SpeechRecognitionBrowserObserverAsyncWaiter&) = delete;

  ~SpeechRecognitionBrowserObserverAsyncWaiter();

 private:
  SpeechRecognitionBrowserObserver* const proxy_;
};


class  SpeechRecognitionClientBrowserInterfaceInterceptorForTesting : public SpeechRecognitionClientBrowserInterface {
  virtual SpeechRecognitionClientBrowserInterface* GetForwardingInterface() = 0;
  void BindSpeechRecognitionBrowserObserver(::mojo::PendingRemote<SpeechRecognitionBrowserObserver> observer) override;
};
class  SpeechRecognitionClientBrowserInterfaceAsyncWaiter {
 public:
  explicit SpeechRecognitionClientBrowserInterfaceAsyncWaiter(SpeechRecognitionClientBrowserInterface* proxy);

  SpeechRecognitionClientBrowserInterfaceAsyncWaiter(const SpeechRecognitionClientBrowserInterfaceAsyncWaiter&) = delete;
  SpeechRecognitionClientBrowserInterfaceAsyncWaiter& operator=(const SpeechRecognitionClientBrowserInterfaceAsyncWaiter&) = delete;

  ~SpeechRecognitionClientBrowserInterfaceAsyncWaiter();

 private:
  SpeechRecognitionClientBrowserInterface* const proxy_;
};


class  MediaFoundationRendererNotifierInterceptorForTesting : public MediaFoundationRendererNotifier {
  virtual MediaFoundationRendererNotifier* GetForwardingInterface() = 0;
  void MediaFoundationRendererCreated() override;
};
class  MediaFoundationRendererNotifierAsyncWaiter {
 public:
  explicit MediaFoundationRendererNotifierAsyncWaiter(MediaFoundationRendererNotifier* proxy);

  MediaFoundationRendererNotifierAsyncWaiter(const MediaFoundationRendererNotifierAsyncWaiter&) = delete;
  MediaFoundationRendererNotifierAsyncWaiter& operator=(const MediaFoundationRendererNotifierAsyncWaiter&) = delete;

  ~MediaFoundationRendererNotifierAsyncWaiter();

 private:
  MediaFoundationRendererNotifier* const proxy_;
};




}  // namespace mojom
}  // namespace media

#endif  // MEDIA_MOJO_MOJOM_SPEECH_RECOGNITION_SERVICE_MOJOM_TEST_UTILS_H_