// services/network/public/mojom/cookie_manager.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_

#include "services/network/public/mojom/cookie_manager.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace network {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT CookieChangeListenerInterceptorForTesting : public CookieChangeListener {
  virtual CookieChangeListener* GetForwardingInterface() = 0;
  void OnCookieChange(CookieChangeInfoPtr change) override;
};
class BLINK_PLATFORM_EXPORT CookieChangeListenerAsyncWaiter {
 public:
  explicit CookieChangeListenerAsyncWaiter(CookieChangeListener* proxy);

  CookieChangeListenerAsyncWaiter(const CookieChangeListenerAsyncWaiter&) = delete;
  CookieChangeListenerAsyncWaiter& operator=(const CookieChangeListenerAsyncWaiter&) = delete;

  ~CookieChangeListenerAsyncWaiter();

 private:
  CookieChangeListener* const proxy_;
};


class BLINK_PLATFORM_EXPORT CookieRemoteAccessFilterInterceptorForTesting : public CookieRemoteAccessFilter {
  virtual CookieRemoteAccessFilter* GetForwardingInterface() = 0;
  void AllowedAccess(const ::blink::KURL& url, const ::net::SiteForCookies& site_for_cookies, AllowedAccessCallback callback) override;
};
class BLINK_PLATFORM_EXPORT CookieRemoteAccessFilterAsyncWaiter {
 public:
  explicit CookieRemoteAccessFilterAsyncWaiter(CookieRemoteAccessFilter* proxy);

  CookieRemoteAccessFilterAsyncWaiter(const CookieRemoteAccessFilterAsyncWaiter&) = delete;
  CookieRemoteAccessFilterAsyncWaiter& operator=(const CookieRemoteAccessFilterAsyncWaiter&) = delete;

  ~CookieRemoteAccessFilterAsyncWaiter();
  void AllowedAccess(
      const ::blink::KURL& url, const ::net::SiteForCookies& site_for_cookies, bool* out_allowed);

 private:
  CookieRemoteAccessFilter* const proxy_;
};


class BLINK_PLATFORM_EXPORT CookieManagerInterceptorForTesting : public CookieManager {
  virtual CookieManager* GetForwardingInterface() = 0;
  void GetAllCookies(GetAllCookiesCallback callback) override;
  void GetAllCookiesWithAccessSemantics(GetAllCookiesWithAccessSemanticsCallback callback) override;
  void GetCookieList(const ::blink::KURL& url, CookieOptionsPtr cookie_options, ::network::mojom::blink::CookiePartitionKeyCollectionPtr cookie_partition_key_collection, GetCookieListCallback callback) override;
  void SetCanonicalCookie(const ::net::CanonicalCookie& cookie, const ::blink::KURL& source_url, CookieOptionsPtr cookie_options, SetCanonicalCookieCallback callback) override;
  void DeleteCanonicalCookie(const ::net::CanonicalCookie& cookie, DeleteCanonicalCookieCallback callback) override;
  void DeleteCookies(CookieDeletionFilterPtr filter, DeleteCookiesCallback callback) override;
  void DeleteSessionOnlyCookies(DeleteSessionOnlyCookiesCallback callback) override;
  void AddCookieChangeListener(const ::blink::KURL& url, const WTF::String& name, ::mojo::PendingRemote<CookieChangeListener> listener) override;
  void AddGlobalChangeListener(::mojo::PendingRemote<CookieChangeListener> notification_pointer) override;
  void CloneInterface(::mojo::PendingReceiver<CookieManager> new_interface) override;
  void FlushCookieStore(FlushCookieStoreCallback callback) override;
  void AllowFileSchemeCookies(bool allow, AllowFileSchemeCookiesCallback callback) override;
  void SetContentSettings(WTF::Vector<::content_settings::mojom::blink::ContentSettingPatternSourcePtr> settings) override;
  void SetRemoteFilter(::mojo::PendingRemote<CookieRemoteAccessFilter> remote_access_filter) override;
  void SetForceKeepSessionState() override;
  void BlockThirdPartyCookies(bool block) override;
  void SetContentSettingsForLegacyCookieAccess(WTF::Vector<::content_settings::mojom::blink::ContentSettingPatternSourcePtr> settings) override;
  void SetStorageAccessGrantSettings(WTF::Vector<::content_settings::mojom::blink::ContentSettingPatternSourcePtr> settings, SetStorageAccessGrantSettingsCallback callback) override;
  void ConvertPartitionedCookiesToUnpartitioned(const ::blink::KURL& url) override;
};
class BLINK_PLATFORM_EXPORT CookieManagerAsyncWaiter {
 public:
  explicit CookieManagerAsyncWaiter(CookieManager* proxy);

  CookieManagerAsyncWaiter(const CookieManagerAsyncWaiter&) = delete;
  CookieManagerAsyncWaiter& operator=(const CookieManagerAsyncWaiter&) = delete;

  ~CookieManagerAsyncWaiter();
  void GetAllCookies(
      WTF::Vector<::net::CanonicalCookie>* out_cookies);
  void GetAllCookiesWithAccessSemantics(
      WTF::Vector<::net::CanonicalCookie>* out_cookies, WTF::Vector<CookieAccessSemantics>* out_access_semantics_list);
  void GetCookieList(
      const ::blink::KURL& url, CookieOptionsPtr cookie_options, ::network::mojom::blink::CookiePartitionKeyCollectionPtr cookie_partition_key_collection, WTF::Vector<CookieWithAccessResultPtr>* out_cookies, WTF::Vector<CookieWithAccessResultPtr>* out_excluded_cookies);
  void SetCanonicalCookie(
      const ::net::CanonicalCookie& cookie, const ::blink::KURL& source_url, CookieOptionsPtr cookie_options, CookieAccessResultPtr* out_access_result);
  void DeleteCanonicalCookie(
      const ::net::CanonicalCookie& cookie, bool* out_success);
  void DeleteCookies(
      CookieDeletionFilterPtr filter, uint32_t* out_num_deleted);
  void DeleteSessionOnlyCookies(
      uint32_t* out_num_deleted);
  void FlushCookieStore(
      );
  void AllowFileSchemeCookies(
      bool allow, bool* out_success);
  void SetStorageAccessGrantSettings(
      WTF::Vector<::content_settings::mojom::blink::ContentSettingPatternSourcePtr> settings);

 private:
  CookieManager* const proxy_;
};




}  // namespace blink
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_COOKIE_MANAGER_MOJOM_BLINK_TEST_UTILS_H_