// services/network/public/mojom/network_context.mojom-blink-test-utils.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2019 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_
#define SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_

#include "services/network/public/mojom/network_context.mojom-blink.h"
#include "third_party/blink/public/platform/web_common.h"


namespace network {
namespace mojom {
namespace blink {


class BLINK_PLATFORM_EXPORT CustomProxyConnectionObserverInterceptorForTesting : public CustomProxyConnectionObserver {
  virtual CustomProxyConnectionObserver* GetForwardingInterface() = 0;
  void OnFallback(::proxy_resolver::mojom::blink::ProxyServerPtr bad_proxy, int32_t net_error) override;
  void OnTunnelHeadersReceived(::proxy_resolver::mojom::blink::ProxyServerPtr proxy_server, ::network::mojom::blink::HttpResponseHeadersPtr response_headers) override;
};
class BLINK_PLATFORM_EXPORT CustomProxyConnectionObserverAsyncWaiter {
 public:
  explicit CustomProxyConnectionObserverAsyncWaiter(CustomProxyConnectionObserver* proxy);

  CustomProxyConnectionObserverAsyncWaiter(const CustomProxyConnectionObserverAsyncWaiter&) = delete;
  CustomProxyConnectionObserverAsyncWaiter& operator=(const CustomProxyConnectionObserverAsyncWaiter&) = delete;

  ~CustomProxyConnectionObserverAsyncWaiter();

 private:
  CustomProxyConnectionObserver* const proxy_;
};


class BLINK_PLATFORM_EXPORT CustomProxyConfigClientInterceptorForTesting : public CustomProxyConfigClient {
  virtual CustomProxyConfigClient* GetForwardingInterface() = 0;
  void OnCustomProxyConfigUpdated(CustomProxyConfigPtr proxy_config, OnCustomProxyConfigUpdatedCallback callback) override;
  void MarkProxiesAsBad(::base::TimeDelta bypass_duration, ::network::mojom::blink::ProxyListPtr bad_proxies, MarkProxiesAsBadCallback callback) override;
  void ClearBadProxiesCache() override;
};
class BLINK_PLATFORM_EXPORT CustomProxyConfigClientAsyncWaiter {
 public:
  explicit CustomProxyConfigClientAsyncWaiter(CustomProxyConfigClient* proxy);

  CustomProxyConfigClientAsyncWaiter(const CustomProxyConfigClientAsyncWaiter&) = delete;
  CustomProxyConfigClientAsyncWaiter& operator=(const CustomProxyConfigClientAsyncWaiter&) = delete;

  ~CustomProxyConfigClientAsyncWaiter();
  void OnCustomProxyConfigUpdated(
      CustomProxyConfigPtr proxy_config);
  void MarkProxiesAsBad(
      ::base::TimeDelta bypass_duration, ::network::mojom::blink::ProxyListPtr bad_proxies);

 private:
  CustomProxyConfigClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT TrustedHeaderClientInterceptorForTesting : public TrustedHeaderClient {
  virtual TrustedHeaderClient* GetForwardingInterface() = 0;
  void OnBeforeSendHeaders(const ::net::HttpRequestHeaders& headers, OnBeforeSendHeadersCallback callback) override;
  void OnHeadersReceived(const WTF::String& headers, const ::net::IPEndPoint& remote_endpoint, OnHeadersReceivedCallback callback) override;
};
class BLINK_PLATFORM_EXPORT TrustedHeaderClientAsyncWaiter {
 public:
  explicit TrustedHeaderClientAsyncWaiter(TrustedHeaderClient* proxy);

  TrustedHeaderClientAsyncWaiter(const TrustedHeaderClientAsyncWaiter&) = delete;
  TrustedHeaderClientAsyncWaiter& operator=(const TrustedHeaderClientAsyncWaiter&) = delete;

  ~TrustedHeaderClientAsyncWaiter();
  void OnBeforeSendHeaders(
      const ::net::HttpRequestHeaders& headers, int32_t* out_result, absl::optional<::net::HttpRequestHeaders>* out_headers);
  void OnHeadersReceived(
      const WTF::String& headers, const ::net::IPEndPoint& remote_endpoint, int32_t* out_result, WTF::String* out_headers, absl::optional<::blink::KURL>* out_preserve_fragment_on_redirect_url);

 private:
  TrustedHeaderClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT TrustedURLLoaderHeaderClientInterceptorForTesting : public TrustedURLLoaderHeaderClient {
  virtual TrustedURLLoaderHeaderClient* GetForwardingInterface() = 0;
  void OnLoaderCreated(int32_t request_id, ::mojo::PendingReceiver<TrustedHeaderClient> header_client) override;
  void OnLoaderForCorsPreflightCreated(const ::network::ResourceRequest& request, ::mojo::PendingReceiver<TrustedHeaderClient> header_client) override;
};
class BLINK_PLATFORM_EXPORT TrustedURLLoaderHeaderClientAsyncWaiter {
 public:
  explicit TrustedURLLoaderHeaderClientAsyncWaiter(TrustedURLLoaderHeaderClient* proxy);

  TrustedURLLoaderHeaderClientAsyncWaiter(const TrustedURLLoaderHeaderClientAsyncWaiter&) = delete;
  TrustedURLLoaderHeaderClientAsyncWaiter& operator=(const TrustedURLLoaderHeaderClientAsyncWaiter&) = delete;

  ~TrustedURLLoaderHeaderClientAsyncWaiter();

 private:
  TrustedURLLoaderHeaderClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT NetworkContextClientInterceptorForTesting : public NetworkContextClient {
  virtual NetworkContextClient* GetForwardingInterface() = 0;
  void OnFileUploadRequested(int32_t process_id, bool async, const WTF::Vector<::base::FilePath>& file_paths, OnFileUploadRequestedCallback callback) override;
  void OnCanSendReportingReports(const WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>& origins, OnCanSendReportingReportsCallback callback) override;
  void OnCanSendDomainReliabilityUpload(const ::blink::KURL& origin, OnCanSendDomainReliabilityUploadCallback callback) override;
  void OnTrustTokenIssuanceDivertedToSystem(::network::mojom::blink::FulfillTrustTokenIssuanceRequestPtr request, OnTrustTokenIssuanceDivertedToSystemCallback callback) override;
  void OnCanSendSCTAuditingReport(OnCanSendSCTAuditingReportCallback callback) override;
  void OnNewSCTAuditingReportSent() override;
};
class BLINK_PLATFORM_EXPORT NetworkContextClientAsyncWaiter {
 public:
  explicit NetworkContextClientAsyncWaiter(NetworkContextClient* proxy);

  NetworkContextClientAsyncWaiter(const NetworkContextClientAsyncWaiter&) = delete;
  NetworkContextClientAsyncWaiter& operator=(const NetworkContextClientAsyncWaiter&) = delete;

  ~NetworkContextClientAsyncWaiter();
  void OnFileUploadRequested(
      int32_t process_id, bool async, const WTF::Vector<::base::FilePath>& file_paths, int32_t* out_net_error, WTF::Vector<::base::File>* out_files);
  void OnCanSendReportingReports(
      const WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>& origins, WTF::Vector<::scoped_refptr<const ::blink::SecurityOrigin>>* out_origins);
  void OnCanSendDomainReliabilityUpload(
      const ::blink::KURL& origin, bool* out_allowed);
  void OnTrustTokenIssuanceDivertedToSystem(
      ::network::mojom::blink::FulfillTrustTokenIssuanceRequestPtr request, ::network::mojom::blink::FulfillTrustTokenIssuanceAnswerPtr* out_response);
  void OnCanSendSCTAuditingReport(
      bool* out_allowed);

 private:
  NetworkContextClient* const proxy_;
};


class BLINK_PLATFORM_EXPORT NetworkContextInterceptorForTesting : public NetworkContext {
  virtual NetworkContext* GetForwardingInterface() = 0;
  void SetClient(::mojo::PendingRemote<NetworkContextClient> client) override;
  void CreateURLLoaderFactory(::mojo::PendingReceiver<::network::mojom::blink::URLLoaderFactory> url_loader_factory, URLLoaderFactoryParamsPtr params) override;
  void ResetURLLoaderFactories() override;
  void GetCookieManager(::mojo::PendingReceiver<::network::mojom::blink::CookieManager> cookie_manager) override;
  void GetRestrictedCookieManager(::mojo::PendingReceiver<::network::mojom::blink::RestrictedCookieManager> restricted_cookie_manager, ::network::mojom::blink::RestrictedCookieManagerRole role, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::net::IsolationInfo& isolation_info, ::mojo::PendingRemote<::network::mojom::blink::CookieAccessObserver> cookie_observer) override;
  void GetHasTrustTokensAnswerer(::mojo::PendingReceiver<::network::mojom::blink::HasTrustTokensAnswerer> has_trust_tokens_answerer, const ::scoped_refptr<const ::blink::SecurityOrigin>& top_frame_origin) override;
  void ClearTrustTokenData(ClearDataFilterPtr filter, ClearTrustTokenDataCallback callback) override;
  void GetStoredTrustTokenCounts(GetStoredTrustTokenCountsCallback callback) override;
  void DeleteStoredTrustTokens(const ::scoped_refptr<const ::blink::SecurityOrigin>& issuer, DeleteStoredTrustTokensCallback callback) override;
  void SetBlockTrustTokens(bool block) override;
  void ClearNetworkingHistoryBetween(::base::Time start_time, ::base::Time end_time, ClearNetworkingHistoryBetweenCallback callback) override;
  void ClearHttpCache(::base::Time start_time, ::base::Time end_time, ClearDataFilterPtr filter, ClearHttpCacheCallback callback) override;
  void ComputeHttpCacheSize(::base::Time start_time, ::base::Time end_time, ComputeHttpCacheSizeCallback callback) override;
  void NotifyExternalCacheHit(const ::blink::KURL& url, const WTF::String& http_method, ::network::mojom::blink::NetworkIsolationKeyPtr key, bool is_subframe_document_resource, bool include_credentials) override;
  void ClearHostCache(ClearDataFilterPtr filter, ClearHostCacheCallback callback) override;
  void ClearHttpAuthCache(::base::Time start_time, ::base::Time end_time, ClearHttpAuthCacheCallback callback) override;
  void ClearReportingCacheReports(ClearDataFilterPtr filter, ClearReportingCacheReportsCallback callback) override;
  void ClearReportingCacheClients(ClearDataFilterPtr filter, ClearReportingCacheClientsCallback callback) override;
  void ClearNetworkErrorLogging(ClearDataFilterPtr filter, ClearNetworkErrorLoggingCallback callback) override;
  void ClearDomainReliability(ClearDataFilterPtr filter, NetworkContext::DomainReliabilityClearMode mode, ClearDomainReliabilityCallback callback) override;
  void GetDomainReliabilityJSON(GetDomainReliabilityJSONCallback callback) override;
  void SetDocumentReportingEndpoints(const ::base::UnguessableToken& reporting_source, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, const ::net::IsolationInfo& isolation_info, const WTF::HashMap<WTF::String, WTF::String>& endpoints) override;
  void SendReportsAndRemoveSource(const ::base::UnguessableToken& reporting_source) override;
  void QueueReport(const WTF::String& type, const WTF::String& group, const ::blink::KURL& url, const absl::optional<::base::UnguessableToken>& reporting_source, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, const WTF::String& user_agent, ::base::Value body) override;
  void QueueSignedExchangeReport(SignedExchangeReportPtr report, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key) override;
  void CloseAllConnections(CloseAllConnectionsCallback callback) override;
  void CloseIdleConnections(CloseIdleConnectionsCallback callback) override;
  void SetNetworkConditions(const ::base::UnguessableToken& throttling_profile_id, NetworkConditionsPtr conditions) override;
  void SetAcceptLanguage(const WTF::String& new_accept_language) override;
  void SetUserAgent(const WTF::String& new_user_agent) override;
  void SetEnableReferrers(bool enable_referrers) override;
  void SetCTPolicy(CTPolicyPtr ct_policy) override;
  void AddExpectCT(const WTF::String& host, ::base::Time expiry, bool enforce, const ::blink::KURL& report_uri, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, AddExpectCTCallback callback) override;
  void SetExpectCTTestReport(const ::blink::KURL& report_uri, SetExpectCTTestReportCallback callback) override;
  void GetExpectCTState(const WTF::String& domain, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, GetExpectCTStateCallback callback) override;
  void CreateUDPSocket(::mojo::PendingReceiver<::network::mojom::blink::UDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::blink::UDPSocketListener> listener) override;
  void CreateTCPServerSocket(const ::net::IPEndPoint& local_addr, uint32_t backlog, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPServerSocket> socket, CreateTCPServerSocketCallback callback) override;
  void CreateTCPConnectedSocket(const absl::optional<::net::IPEndPoint>& local_addr, ::network::mojom::blink::AddressListPtr remote_addr_list, ::network::mojom::blink::TCPConnectedSocketOptionsPtr tcp_connected_socket_options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPConnectedSocket> socket, ::mojo::PendingRemote<::network::mojom::blink::SocketObserver> observer, CreateTCPConnectedSocketCallback callback) override;
  void CreateTCPBoundSocket(const ::net::IPEndPoint& local_addr, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPBoundSocket> socket, CreateTCPBoundSocketCallback callback) override;
  void CreateProxyResolvingSocketFactory(::mojo::PendingReceiver<::network::mojom::blink::ProxyResolvingSocketFactory> factory) override;
  void LookUpProxyForURL(const ::blink::KURL& url, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::mojo::PendingRemote<::network::mojom::blink::ProxyLookupClient> proxy_lookup_client) override;
  void ForceReloadProxyConfig(ForceReloadProxyConfigCallback callback) override;
  void ClearBadProxiesCache(ClearBadProxiesCacheCallback callback) override;
  void CreateWebSocket(const ::blink::KURL& url, const WTF::Vector<WTF::String>& requested_protocols, const ::net::SiteForCookies& site_for_cookies, const ::net::IsolationInfo& isolation_info, WTF::Vector<::network::mojom::blink::HttpHeaderPtr> additional_headers, int32_t process_id, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, uint32_t options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingRemote<::network::mojom::blink::WebSocketHandshakeClient> handshake_client, ::mojo::PendingRemote<::network::mojom::blink::URLLoaderNetworkServiceObserver> url_loader_network_observer, ::mojo::PendingRemote<::network::mojom::blink::WebSocketAuthenticationHandler> auth_handler, ::mojo::PendingRemote<TrustedHeaderClient> header_client, const absl::optional<::base::UnguessableToken>& throttling_profile_id) override;
  void CreateWebTransport(const ::blink::KURL& url, const ::scoped_refptr<const ::blink::SecurityOrigin>& origin, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, WTF::Vector<::network::mojom::blink::WebTransportCertificateFingerprintPtr> fingerprints, ::mojo::PendingRemote<::network::mojom::blink::WebTransportHandshakeClient> handshake_client) override;
  void CreateNetLogExporter(::mojo::PendingReceiver<::network::mojom::blink::NetLogExporter> receiver) override;
  void PreconnectSockets(uint32_t num_streams, const ::blink::KURL& url, bool allow_credentials, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key) override;
  void CreateP2PSocketManager(::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::mojo::PendingRemote<::network::mojom::blink::P2PTrustedSocketManagerClient> client, ::mojo::PendingReceiver<::network::mojom::blink::P2PTrustedSocketManager> trusted_socket_manager, ::mojo::PendingReceiver<::network::mojom::blink::P2PSocketManager> socket_manager) override;
  void CreateMdnsResponder(::mojo::PendingReceiver<::network::mojom::blink::MdnsResponder> responder_receiver) override;
  void ResolveHost(::network::mojom::blink::HostPortPairPtr host, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::network::mojom::blink::ResolveHostParametersPtr optional_parameters, ::mojo::PendingRemote<::network::mojom::blink::ResolveHostClient> response_client) override;
  void CreateHostResolver(::network::mojom::blink::DnsConfigOverridesPtr config_overrides, ::mojo::PendingReceiver<::network::mojom::blink::HostResolver> host_resolver) override;
  void VerifyCertForSignedExchange(::network::mojom::blink::X509CertificatePtr certificate, const ::blink::KURL& url, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, const WTF::String& ocsp_response, const WTF::String& sct_list, VerifyCertForSignedExchangeCallback callback) override;
  void AddHSTS(const WTF::String& host, ::base::Time expiry, bool include_subdomains, AddHSTSCallback callback) override;
  void IsHSTSActiveForHost(const WTF::String& host, IsHSTSActiveForHostCallback callback) override;
  void GetHSTSState(const WTF::String& domain, GetHSTSStateCallback callback) override;
  void SetCorsOriginAccessListsForOrigin(const ::scoped_refptr<const ::blink::SecurityOrigin>& source_origin, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> allow_patterns, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> block_patterns, SetCorsOriginAccessListsForOriginCallback callback) override;
  void DeleteDynamicDataForHost(const WTF::String& host, DeleteDynamicDataForHostCallback callback) override;
  void SetSplitAuthCacheByNetworkIsolationKey(bool split_auth_cache_by_network_isolation_key) override;
  void SaveHttpAuthCacheProxyEntries(SaveHttpAuthCacheProxyEntriesCallback callback) override;
  void LoadHttpAuthCacheProxyEntries(const ::base::UnguessableToken& cache_key, LoadHttpAuthCacheProxyEntriesCallback callback) override;
  void AddAuthCacheEntry(const ::net::AuthChallengeInfo& challenge, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::network::mojom::blink::AuthCredentialsPtr credentials, AddAuthCacheEntryCallback callback) override;
  void SetCorsNonWildcardRequestHeadersSupport(bool value) override;
  void LookupServerBasicAuthCredentials(const ::blink::KURL& url, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, LookupServerBasicAuthCredentialsCallback callback) override;
  void EnableStaticKeyPinningForTesting(EnableStaticKeyPinningForTestingCallback callback) override;
  void VerifyCertificateForTesting(::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, const WTF::String& ocsp_response, const WTF::String& sct_list, VerifyCertificateForTestingCallback callback) override;
  void AddDomainReliabilityContextForTesting(const ::blink::KURL& origin, const ::blink::KURL& upload_url, AddDomainReliabilityContextForTestingCallback callback) override;
  void ForceDomainReliabilityUploadsForTesting(ForceDomainReliabilityUploadsForTestingCallback callback) override;
  void GetOriginPolicyManager(::mojo::PendingReceiver<::network::mojom::blink::OriginPolicyManager> origin_policy_manager) override;
  void SetCTLogListAlwaysTimelyForTesting() override;
  void SetSCTAuditingMode(SCTAuditingMode mode) override;
};
class BLINK_PLATFORM_EXPORT NetworkContextAsyncWaiter {
 public:
  explicit NetworkContextAsyncWaiter(NetworkContext* proxy);

  NetworkContextAsyncWaiter(const NetworkContextAsyncWaiter&) = delete;
  NetworkContextAsyncWaiter& operator=(const NetworkContextAsyncWaiter&) = delete;

  ~NetworkContextAsyncWaiter();
  void ClearTrustTokenData(
      ClearDataFilterPtr filter);
  void GetStoredTrustTokenCounts(
      WTF::Vector<::network::mojom::blink::StoredTrustTokensForIssuerPtr>* out_tokens);
  void DeleteStoredTrustTokens(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& issuer, ::network::mojom::blink::DeleteStoredTrustTokensStatus* out_status);
  void ClearNetworkingHistoryBetween(
      ::base::Time start_time, ::base::Time end_time);
  void ClearHttpCache(
      ::base::Time start_time, ::base::Time end_time, ClearDataFilterPtr filter);
  void ComputeHttpCacheSize(
      ::base::Time start_time, ::base::Time end_time, bool* out_is_upper_bound, int64_t* out_size_or_error);
  void ClearHostCache(
      ClearDataFilterPtr filter);
  void ClearHttpAuthCache(
      ::base::Time start_time, ::base::Time end_time);
  void ClearReportingCacheReports(
      ClearDataFilterPtr filter);
  void ClearReportingCacheClients(
      ClearDataFilterPtr filter);
  void ClearNetworkErrorLogging(
      ClearDataFilterPtr filter);
  void ClearDomainReliability(
      ClearDataFilterPtr filter, NetworkContext::DomainReliabilityClearMode mode);
  void GetDomainReliabilityJSON(
      ::base::Value* out_data);
  void CloseAllConnections(
      );
  void CloseIdleConnections(
      );
  void AddExpectCT(
      const WTF::String& host, ::base::Time expiry, bool enforce, const ::blink::KURL& report_uri, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, bool* out_success);
  void SetExpectCTTestReport(
      const ::blink::KURL& report_uri, bool* out_success);
  void GetExpectCTState(
      const WTF::String& domain, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::base::Value* out_state);
  void CreateTCPServerSocket(
      const ::net::IPEndPoint& local_addr, uint32_t backlog, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPServerSocket> socket, int32_t* out_result, absl::optional<::net::IPEndPoint>* out_local_addr_out);
  void CreateTCPConnectedSocket(
      const absl::optional<::net::IPEndPoint>& local_addr, ::network::mojom::blink::AddressListPtr remote_addr_list, ::network::mojom::blink::TCPConnectedSocketOptionsPtr tcp_connected_socket_options, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPConnectedSocket> socket, ::mojo::PendingRemote<::network::mojom::blink::SocketObserver> observer, int32_t* out_result, absl::optional<::net::IPEndPoint>* out_local_addr, absl::optional<::net::IPEndPoint>* out_peer_addr, ::mojo::ScopedDataPipeConsumerHandle* out_receive_stream, ::mojo::ScopedDataPipeProducerHandle* out_send_stream);
  void CreateTCPBoundSocket(
      const ::net::IPEndPoint& local_addr, const ::net::MutableNetworkTrafficAnnotationTag& traffic_annotation, ::mojo::PendingReceiver<::network::mojom::blink::TCPBoundSocket> socket, int32_t* out_result, absl::optional<::net::IPEndPoint>* out_local_addr);
  void ForceReloadProxyConfig(
      );
  void ClearBadProxiesCache(
      );
  void VerifyCertForSignedExchange(
      ::network::mojom::blink::X509CertificatePtr certificate, const ::blink::KURL& url, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, const WTF::String& ocsp_response, const WTF::String& sct_list, int32_t* out_error_code, ::network::mojom::blink::CertVerifyResultPtr* out_cv_result, bool* out_pkp_bypassed, WTF::String* out_pinning_failure_log);
  void AddHSTS(
      const WTF::String& host, ::base::Time expiry, bool include_subdomains);
  void IsHSTSActiveForHost(
      const WTF::String& host, bool* out_result);
  void GetHSTSState(
      const WTF::String& domain, ::base::Value* out_state);
  void SetCorsOriginAccessListsForOrigin(
      const ::scoped_refptr<const ::blink::SecurityOrigin>& source_origin, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> allow_patterns, WTF::Vector<::network::mojom::blink::CorsOriginPatternPtr> block_patterns);
  void DeleteDynamicDataForHost(
      const WTF::String& host, bool* out_result);
  void SaveHttpAuthCacheProxyEntries(
      ::base::UnguessableToken* out_cache_key);
  void LoadHttpAuthCacheProxyEntries(
      const ::base::UnguessableToken& cache_key);
  void AddAuthCacheEntry(
      const ::net::AuthChallengeInfo& challenge, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::network::mojom::blink::AuthCredentialsPtr credentials);
  void LookupServerBasicAuthCredentials(
      const ::blink::KURL& url, ::network::mojom::blink::NetworkIsolationKeyPtr network_isolation_key, ::network::mojom::blink::AuthCredentialsPtr* out_credentials);
  void EnableStaticKeyPinningForTesting(
      );
  void VerifyCertificateForTesting(
      ::network::mojom::blink::X509CertificatePtr certificate, const WTF::String& hostname, const WTF::String& ocsp_response, const WTF::String& sct_list, int32_t* out_error_code);
  void AddDomainReliabilityContextForTesting(
      const ::blink::KURL& origin, const ::blink::KURL& upload_url);
  void ForceDomainReliabilityUploadsForTesting(
      );

 private:
  NetworkContext* const proxy_;
};




}  // namespace blink
}  // namespace mojom
}  // namespace network

#endif  // SERVICES_NETWORK_PUBLIC_MOJOM_NETWORK_CONTEXT_MOJOM_BLINK_TEST_UTILS_H_