// Copyright (c) 2014 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/origin_trial_feature.h.tmpl
// and input files:
//   ../../../../../../qtwebengine/src/3rdparty/chromium/third_party/blink/renderer/platform/runtime_enabled_features.json5


#ifndef THIRD_PARTY_BLINK_PUBLIC_COMMON_ORIGIN_TRIALS_ORIGIN_TRIAL_FEATURE_H_
#define THIRD_PARTY_BLINK_PUBLIC_COMMON_ORIGIN_TRIALS_ORIGIN_TRIAL_FEATURE_H_

#include <cstdint>

namespace blink {

enum class OriginTrialFeature : int32_t {
  // For testing
  kNonExisting = 0,

  kAccessibilityAriaTouchPassthrough,
  kAdInterestGroupAPI,
  kAttributionReporting,
  kAutoDarkMode,
  kBackForwardCacheExperimentHTTPHeader,
  kBatterySavingsMeta,
  kBeforeMatchEvent,
  kCacheStorageCodeCacheHint,
  kCapabilityDelegation,
  kCapabilityDelegationPaymentRequest,
  kComputePressure,
  kConditionalFocus,
  kCrossOriginOpenerPolicyReporting,
  kCSSColorSchemeOnly,
  kCSSContentVisibilityHiddenMatchable,
  kDeviceAttributes,
  kDigitalGoods,
  kDisableDifferentOriginSubframeDialogSuppression,
  kDisableHardwareNoiseSuppression,
  kDocumentPolicyNegotiation,
  kEarlyHintsPreloadForNavigationOptIn,
  kExperimentalIsInputPending,
  kExperimentalJSProfiler,
  kFedCm,
  kFencedFrames,
  kFetchUploadStreaming,
  kFileHandling,
  kFledge,
  kFontAccess,
  kHrefTranslate,
  kMediaSourceExtensionsForWebCodecs,
  kMediaSourceInWorkers,
  kMediaStreamInsertableStreams,
  kNotificationTriggers,
  kOriginTrialsSampleAPI,
  kOriginTrialsSampleAPIDeprecation,
  kOriginTrialsSampleAPIExpiryGracePeriod,
  kOriginTrialsSampleAPIImplied,
  kOriginTrialsSampleAPIInvalidOS,
  kOriginTrialsSampleAPINavigation,
  kOriginTrialsSampleAPIThirdParty,
  kPageFreezeOptIn,
  kPageFreezeOptOut,
  kParakeet,
  kPartitionedCookies,
  kPerMethodCanMakePaymentQuota,
  kPNaCl,
  kPointerLockOptions,
  kPortals,
  kPrerender2,
  kPrerender2RelatedFeatures,
  kPrivacySandboxAdsAPIs,
  kPrivateNetworkAccessNonSecureContextsAllowed,
  kRegionCapture,
  kRtcAudioJitterBufferMaxPackets,
  kRtcAudioJitterBufferRtxHandling,
  kRTCIceTransportExtension,
  kRTCInsertableStreams,
  kRTCQuicTransport,
  kRTCStatsRelativePacketArrivalDelay,
  kSendFullUserAgentAfterReduction,
  kSignatureBasedIntegrity,
  kSignedExchangeSubresourcePrefetch,
  kSkipAd,
  kSpeculationRules,
  kSpeculationRulesPrefetchProxy,
  kStorageFoundationAPI,
  kTextFragmentIdentifiers,
  kTopicsAPI,
  kTouchEventFeatureDetection,
  kTrustTokens,
  kU2FSecurityKeyAPI,
  kUnrestrictedSharedArrayBuffer,
  kUserAgentReduction,
  kViewportHeightClientHintHeader,
  kWebAppDarkMode,
  kWebAppLaunchHandler,
  kWebAppLaunchQueue,
  kWebAppUrlHandling,
  kWebAppWindowControlsOverlay,
  kWebAssemblyDynamicTiering,
  kWebAssemblyExceptions,
  kWebCodecs,
  kWebGPU,
  kWebTransportCustomCertificates,
  kWebXRDepth,
  kWebXRImageTracking,
  kWebXRPlaneDetection,
};

}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_COMMON_ORIGIN_TRIALS_ORIGIN_TRIAL_FEATURE_H_
