// third_party/blink/public/mojom/compute_pressure/compute_pressure.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_COMPUTE_PRESSURE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_COMPUTE_PRESSURE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/compute_pressure/compute_pressure.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "base/component_export.h"




namespace blink {
namespace mojom {
class ComputePressureStateDataView;

class ComputePressureQuantizationDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::ComputePressureStateDataView> {
  using Data = ::blink::mojom::internal::ComputePressureState_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

template <>
struct MojomTypeTraits<::blink::mojom::ComputePressureQuantizationDataView> {
  using Data = ::blink::mojom::internal::ComputePressureQuantization_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class ComputePressureStatus : int32_t {
  
  kOk = 0,
  
  kNotSupported = 1,
  
  kSecurityError = 2,
  kMinValue = 0,
  kMaxValue = 2,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, ComputePressureStatus value);
inline bool IsKnownEnumValue(ComputePressureStatus value) {
  return internal::ComputePressureStatus_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class ComputePressureObserverInterfaceBase {};

using ComputePressureObserverPtrDataView =
    mojo::InterfacePtrDataView<ComputePressureObserverInterfaceBase>;
using ComputePressureObserverRequestDataView =
    mojo::InterfaceRequestDataView<ComputePressureObserverInterfaceBase>;
using ComputePressureObserverAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ComputePressureObserverInterfaceBase>;
using ComputePressureObserverAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ComputePressureObserverInterfaceBase>;
class ComputePressureHostInterfaceBase {};

using ComputePressureHostPtrDataView =
    mojo::InterfacePtrDataView<ComputePressureHostInterfaceBase>;
using ComputePressureHostRequestDataView =
    mojo::InterfaceRequestDataView<ComputePressureHostInterfaceBase>;
using ComputePressureHostAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<ComputePressureHostInterfaceBase>;
using ComputePressureHostAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<ComputePressureHostInterfaceBase>;


class ComputePressureStateDataView {
 public:
  ComputePressureStateDataView() = default;

  ComputePressureStateDataView(
      internal::ComputePressureState_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  double cpu_utilization() const {
    return data_->cpu_utilization;
  }
  double cpu_speed() const {
    return data_->cpu_speed;
  }
 private:
  internal::ComputePressureState_Data* data_ = nullptr;
};



class ComputePressureQuantizationDataView {
 public:
  ComputePressureQuantizationDataView() = default;

  ComputePressureQuantizationDataView(
      internal::ComputePressureQuantization_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetCpuUtilizationThresholdsDataView(
      mojo::ArrayDataView<double>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadCpuUtilizationThresholds(UserType* output) {
    
    auto* pointer = data_->cpu_utilization_thresholds.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<double>>(
        pointer, output, message_);
  }
  inline void GetCpuSpeedThresholdsDataView(
      mojo::ArrayDataView<double>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadCpuSpeedThresholds(UserType* output) {
    
    auto* pointer = data_->cpu_speed_thresholds.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<double>>(
        pointer, output, message_);
  }
 private:
  internal::ComputePressureQuantization_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::ComputePressureStatus>
    : public mojo::internal::EnumHashImpl<::blink::mojom::ComputePressureStatus> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ComputePressureStatus, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::ComputePressureStatus, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::ComputePressureStatus>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ComputePressureStateDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ComputePressureStateDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ComputePressureState_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->cpu_utilization = Traits::cpu_utilization(input);
    fragment->cpu_speed = Traits::cpu_speed(input);
  }

  static bool Deserialize(::blink::mojom::internal::ComputePressureState_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ComputePressureStateDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::ComputePressureQuantizationDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::ComputePressureQuantizationDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::ComputePressureQuantization_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::cpu_utilization_thresholds(input)) in_cpu_utilization_thresholds = Traits::cpu_utilization_thresholds(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->cpu_utilization_thresholds)::BaseType>
        cpu_utilization_thresholds_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams cpu_utilization_thresholds_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<double>>(
        in_cpu_utilization_thresholds, cpu_utilization_thresholds_fragment, &cpu_utilization_thresholds_validate_params);
    fragment->cpu_utilization_thresholds.Set(
        cpu_utilization_thresholds_fragment.is_null() ? nullptr : cpu_utilization_thresholds_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->cpu_utilization_thresholds.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cpu_utilization_thresholds in ComputePressureQuantization struct");
    decltype(Traits::cpu_speed_thresholds(input)) in_cpu_speed_thresholds = Traits::cpu_speed_thresholds(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->cpu_speed_thresholds)::BaseType>
        cpu_speed_thresholds_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams cpu_speed_thresholds_validate_params(
        0, false, nullptr);
    mojo::internal::Serialize<mojo::ArrayDataView<double>>(
        in_cpu_speed_thresholds, cpu_speed_thresholds_fragment, &cpu_speed_thresholds_validate_params);
    fragment->cpu_speed_thresholds.Set(
        cpu_speed_thresholds_fragment.is_null() ? nullptr : cpu_speed_thresholds_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->cpu_speed_thresholds.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null cpu_speed_thresholds in ComputePressureQuantization struct");
  }

  static bool Deserialize(::blink::mojom::internal::ComputePressureQuantization_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::ComputePressureQuantizationDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {



inline void ComputePressureQuantizationDataView::GetCpuUtilizationThresholdsDataView(
    mojo::ArrayDataView<double>* output) {
  auto pointer = data_->cpu_utilization_thresholds.Get();
  *output = mojo::ArrayDataView<double>(pointer, message_);
}
inline void ComputePressureQuantizationDataView::GetCpuSpeedThresholdsDataView(
    mojo::ArrayDataView<double>* output) {
  auto pointer = data_->cpu_speed_thresholds.Get();
  *output = mojo::ArrayDataView<double>(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::ComputePressureStatus> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::ComputePressureStatus value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_COMPUTE_PRESSURE_COMPUTE_PRESSURE_MOJOM_SHARED_H_