// third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared-internal.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom-shared.h"
#include "services/network/public/mojom/ip_endpoint.mojom-shared.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-shared.h"
#include "services/network/public/mojom/tcp_socket.mojom-shared.h"
#include "services/network/public/mojom/udp_socket.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "base/component_export.h"




namespace blink {
namespace mojom {
class DirectSocketOptionsDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::DirectSocketOptionsDataView> {
  using Data = ::blink::mojom::internal::DirectSocketOptions_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class DirectSocketFailureType : int32_t {
  
  kPermissionsPolicy = 0,
  
  kTransientActivation = 1,
  
  kUserDialog = 2,
  
  kResolvingToNonPublic = 3,
  
  kRateLimiting = 4,
  
  kCORS = 5,
  
  kEnterprisePolicy = 6,
  kMinValue = 0,
  kMaxValue = 6,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, DirectSocketFailureType value);
inline bool IsKnownEnumValue(DirectSocketFailureType value) {
  return internal::DirectSocketFailureType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class DirectSocketsServiceInterfaceBase {};

using DirectSocketsServicePtrDataView =
    mojo::InterfacePtrDataView<DirectSocketsServiceInterfaceBase>;
using DirectSocketsServiceRequestDataView =
    mojo::InterfaceRequestDataView<DirectSocketsServiceInterfaceBase>;
using DirectSocketsServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DirectSocketsServiceInterfaceBase>;
using DirectSocketsServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DirectSocketsServiceInterfaceBase>;
class DirectUDPSocketInterfaceBase {};

using DirectUDPSocketPtrDataView =
    mojo::InterfacePtrDataView<DirectUDPSocketInterfaceBase>;
using DirectUDPSocketRequestDataView =
    mojo::InterfaceRequestDataView<DirectUDPSocketInterfaceBase>;
using DirectUDPSocketAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<DirectUDPSocketInterfaceBase>;
using DirectUDPSocketAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<DirectUDPSocketInterfaceBase>;


class DirectSocketOptionsDataView {
 public:
  DirectSocketOptionsDataView() = default;

  DirectSocketOptionsDataView(
      internal::DirectSocketOptions_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetLocalHostnameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadLocalHostname(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `local_hostname` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadLocalHostname` instead "
    "of `ReadLocalHostname if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->local_hostname.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  uint16_t local_port() const {
    return data_->local_port;
  }
  inline void GetRemoteHostnameDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadRemoteHostname(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        mojo::StringDataView, UserType>(),
    "Attempting to read the optional `remote_hostname` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadRemoteHostname` instead "
    "of `ReadRemoteHostname if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->remote_hostname.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  uint16_t remote_port() const {
    return data_->remote_port;
  }
  int32_t send_buffer_size() const {
    return data_->send_buffer_size;
  }
  int32_t receive_buffer_size() const {
    return data_->receive_buffer_size;
  }
  bool no_delay() const {
    return data_->no_delay;
  }
  inline void GetKeepAliveOptionsDataView(
      ::network::mojom::TCPKeepAliveOptionsDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadKeepAliveOptions(UserType* output) {
    
static_assert(
    mojo::internal::IsValidUserTypeForOptionalValue<
        ::network::mojom::TCPKeepAliveOptionsDataView, UserType>(),
    "Attempting to read the optional `keep_alive_options` field into a type which "
    "cannot represent a null value. Either wrap the destination object "
    "with absl::optional, ensure that any corresponding "
    "{Struct/Union/Array/String}Traits define the necessary IsNull and "
    "SetToNull methods, or use `MaybeReadKeepAliveOptions` instead "
    "of `ReadKeepAliveOptions if you're fine with null values being "
    "silently ignored in this case.");
    auto* pointer = data_->keep_alive_options.Get();
    return mojo::internal::Deserialize<::network::mojom::TCPKeepAliveOptionsDataView>(
        pointer, output, message_);
  }
 private:
  internal::DirectSocketOptions_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::DirectSocketFailureType>
    : public mojo::internal::EnumHashImpl<::blink::mojom::DirectSocketFailureType> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DirectSocketFailureType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::DirectSocketFailureType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::DirectSocketFailureType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::DirectSocketOptionsDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::DirectSocketOptionsDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::DirectSocketOptions_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::local_hostname(input)) in_local_hostname = Traits::local_hostname(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->local_hostname)::BaseType> local_hostname_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_local_hostname, local_hostname_fragment);
    fragment->local_hostname.Set(
        local_hostname_fragment.is_null() ? nullptr : local_hostname_fragment.data());
    fragment->local_port = Traits::local_port(input);
    decltype(Traits::remote_hostname(input)) in_remote_hostname = Traits::remote_hostname(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->remote_hostname)::BaseType> remote_hostname_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_remote_hostname, remote_hostname_fragment);
    fragment->remote_hostname.Set(
        remote_hostname_fragment.is_null() ? nullptr : remote_hostname_fragment.data());
    fragment->remote_port = Traits::remote_port(input);
    fragment->send_buffer_size = Traits::send_buffer_size(input);
    fragment->receive_buffer_size = Traits::receive_buffer_size(input);
    fragment->no_delay = Traits::no_delay(input);
    decltype(Traits::keep_alive_options(input)) in_keep_alive_options = Traits::keep_alive_options(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->keep_alive_options)::BaseType> keep_alive_options_fragment(
            fragment.message());
    mojo::internal::Serialize<::network::mojom::TCPKeepAliveOptionsDataView>(
        in_keep_alive_options, keep_alive_options_fragment);
    fragment->keep_alive_options.Set(
        keep_alive_options_fragment.is_null() ? nullptr : keep_alive_options_fragment.data());
  }

  static bool Deserialize(::blink::mojom::internal::DirectSocketOptions_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::DirectSocketOptionsDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void DirectSocketOptionsDataView::GetLocalHostnameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->local_hostname.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void DirectSocketOptionsDataView::GetRemoteHostnameDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->remote_hostname.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void DirectSocketOptionsDataView::GetKeepAliveOptionsDataView(
    ::network::mojom::TCPKeepAliveOptionsDataView* output) {
  auto pointer = data_->keep_alive_options.Get();
  *output = ::network::mojom::TCPKeepAliveOptionsDataView(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::DirectSocketFailureType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::DirectSocketFailureType value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_SHARED_H_