// third_party/blink/public/mojom/mobile_metrics/mobile_friendliness.mojom-blink.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_MOBILE_METRICS_MOBILE_FRIENDLINESS_MOJOM_BLINK_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_MOBILE_METRICS_MOBILE_FRIENDLINESS_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/mobile_metrics/mobile_friendliness.mojom-shared.h"
#include "third_party/blink/public/mojom/mobile_metrics/mobile_friendliness.mojom-blink-forward.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"








namespace blink {
namespace mojom {
namespace blink {








class  MobileFriendliness {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<MobileFriendliness, T>::value>;
  using DataView = MobileFriendlinessDataView;
  using Data_ = internal::MobileFriendliness_Data;

  template <typename... Args>
  static MobileFriendlinessPtr New(Args&&... args) {
    return MobileFriendlinessPtr(
        base::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static MobileFriendlinessPtr From(const U& u) {
    return mojo::TypeConverter<MobileFriendlinessPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, MobileFriendliness>::Convert(*this);
  }


  MobileFriendliness();

  MobileFriendliness(
      bool viewport_device_width,
      int32_t viewport_initial_scale_x10,
      int32_t viewport_hardcoded_width,
      bool allow_user_zoom,
      int32_t small_text_ratio,
      int32_t text_content_outside_viewport_percentage,
      int32_t bad_tap_targets_ratio);


  ~MobileFriendliness();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = MobileFriendlinessPtr>
  MobileFriendlinessPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  size_t Hash(size_t seed) const;
  template <typename UserType>
  static WTF::Vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        MobileFriendliness::DataView, WTF::Vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        MobileFriendliness::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::MobileFriendliness_UnserializedMessageContext<
            UserType, MobileFriendliness::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<MobileFriendliness::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const WTF::Vector<uint8_t>& input,
                          UserType* output) {
    return MobileFriendliness::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::MobileFriendliness_UnserializedMessageContext<
            UserType, MobileFriendliness::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<MobileFriendliness::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  bool viewport_device_width;
  
  int32_t viewport_initial_scale_x10;
  
  int32_t viewport_hardcoded_width;
  
  bool allow_user_zoom;
  
  int32_t small_text_ratio;
  
  int32_t text_content_outside_viewport_percentage;
  
  int32_t bad_tap_targets_ratio;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, MobileFriendliness::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
MobileFriendlinessPtr MobileFriendliness::Clone() const {
  return New(
      mojo::Clone(viewport_device_width),
      mojo::Clone(viewport_initial_scale_x10),
      mojo::Clone(viewport_hardcoded_width),
      mojo::Clone(allow_user_zoom),
      mojo::Clone(small_text_ratio),
      mojo::Clone(text_content_outside_viewport_percentage),
      mojo::Clone(bad_tap_targets_ratio)
  );
}

template <typename T, MobileFriendliness::EnableIfSame<T>*>
bool MobileFriendliness::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->viewport_device_width, other_struct.viewport_device_width))
    return false;
  if (!mojo::Equals(this->viewport_initial_scale_x10, other_struct.viewport_initial_scale_x10))
    return false;
  if (!mojo::Equals(this->viewport_hardcoded_width, other_struct.viewport_hardcoded_width))
    return false;
  if (!mojo::Equals(this->allow_user_zoom, other_struct.allow_user_zoom))
    return false;
  if (!mojo::Equals(this->small_text_ratio, other_struct.small_text_ratio))
    return false;
  if (!mojo::Equals(this->text_content_outside_viewport_percentage, other_struct.text_content_outside_viewport_percentage))
    return false;
  if (!mojo::Equals(this->bad_tap_targets_ratio, other_struct.bad_tap_targets_ratio))
    return false;
  return true;
}

template <typename T, MobileFriendliness::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.viewport_device_width < rhs.viewport_device_width)
    return true;
  if (rhs.viewport_device_width < lhs.viewport_device_width)
    return false;
  if (lhs.viewport_initial_scale_x10 < rhs.viewport_initial_scale_x10)
    return true;
  if (rhs.viewport_initial_scale_x10 < lhs.viewport_initial_scale_x10)
    return false;
  if (lhs.viewport_hardcoded_width < rhs.viewport_hardcoded_width)
    return true;
  if (rhs.viewport_hardcoded_width < lhs.viewport_hardcoded_width)
    return false;
  if (lhs.allow_user_zoom < rhs.allow_user_zoom)
    return true;
  if (rhs.allow_user_zoom < lhs.allow_user_zoom)
    return false;
  if (lhs.small_text_ratio < rhs.small_text_ratio)
    return true;
  if (rhs.small_text_ratio < lhs.small_text_ratio)
    return false;
  if (lhs.text_content_outside_viewport_percentage < rhs.text_content_outside_viewport_percentage)
    return true;
  if (rhs.text_content_outside_viewport_percentage < lhs.text_content_outside_viewport_percentage)
    return false;
  if (lhs.bad_tap_targets_ratio < rhs.bad_tap_targets_ratio)
    return true;
  if (rhs.bad_tap_targets_ratio < lhs.bad_tap_targets_ratio)
    return false;
  return false;
}


}  // namespace blink
}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct  StructTraits<::blink::mojom::blink::MobileFriendliness::DataView,
                                         ::blink::mojom::blink::MobileFriendlinessPtr> {
  static bool IsNull(const ::blink::mojom::blink::MobileFriendlinessPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::blink::MobileFriendlinessPtr* output) { output->reset(); }

  static decltype(::blink::mojom::blink::MobileFriendliness::viewport_device_width) viewport_device_width(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->viewport_device_width;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::viewport_initial_scale_x10) viewport_initial_scale_x10(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->viewport_initial_scale_x10;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::viewport_hardcoded_width) viewport_hardcoded_width(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->viewport_hardcoded_width;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::allow_user_zoom) allow_user_zoom(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->allow_user_zoom;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::small_text_ratio) small_text_ratio(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->small_text_ratio;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::text_content_outside_viewport_percentage) text_content_outside_viewport_percentage(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->text_content_outside_viewport_percentage;
  }

  static decltype(::blink::mojom::blink::MobileFriendliness::bad_tap_targets_ratio) bad_tap_targets_ratio(
      const ::blink::mojom::blink::MobileFriendlinessPtr& input) {
    return input->bad_tap_targets_ratio;
  }

  static bool Read(::blink::mojom::blink::MobileFriendliness::DataView input, ::blink::mojom::blink::MobileFriendlinessPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_MOBILE_METRICS_MOBILE_FRIENDLINESS_MOJOM_BLINK_H_