// third_party/blink/public/mojom/subapps/sub_apps_service.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_SUBAPPS_SUB_APPS_SERVICE_MOJOM_SHARED_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_SUBAPPS_SUB_APPS_SERVICE_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/subapps/sub_apps_service.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "base/component_export.h"




namespace blink {
namespace mojom {
class SubAppsServiceListResultDataView;



}  // namespace mojom
}  // namespace blink

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::blink::mojom::SubAppsServiceListResultDataView> {
  using Data = ::blink::mojom::internal::SubAppsServiceListResult_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace blink {
namespace mojom {


enum class SubAppsServiceResult : int32_t {
  
  kSuccess = 0,
  
  kFailure = 1,
  kMinValue = 0,
  kMaxValue = 1,
};

COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) std::ostream& operator<<(std::ostream& os, SubAppsServiceResult value);
inline bool IsKnownEnumValue(SubAppsServiceResult value) {
  return internal::SubAppsServiceResult_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class SubAppsServiceInterfaceBase {};

using SubAppsServicePtrDataView =
    mojo::InterfacePtrDataView<SubAppsServiceInterfaceBase>;
using SubAppsServiceRequestDataView =
    mojo::InterfaceRequestDataView<SubAppsServiceInterfaceBase>;
using SubAppsServiceAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<SubAppsServiceInterfaceBase>;
using SubAppsServiceAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<SubAppsServiceInterfaceBase>;


class SubAppsServiceListResultDataView {
 public:
  SubAppsServiceListResultDataView() = default;

  SubAppsServiceListResultDataView(
      internal::SubAppsServiceListResult_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  [[nodiscard]] bool ReadCode(UserType* output) const {
    auto data_value = data_->code;
    return mojo::internal::Deserialize<::blink::mojom::SubAppsServiceResult>(
        data_value, output);
  }
  SubAppsServiceResult code() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::blink::mojom::SubAppsServiceResult>(data_->code));
  }
  inline void GetSubAppIdsDataView(
      mojo::ArrayDataView<mojo::StringDataView>* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSubAppIds(UserType* output) {
    
    auto* pointer = data_->sub_app_ids.Get();
    return mojo::internal::Deserialize<mojo::ArrayDataView<mojo::StringDataView>>(
        pointer, output, message_);
  }
 private:
  internal::SubAppsServiceListResult_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};



}  // namespace mojom
}  // namespace blink

namespace std {

template <>
struct hash<::blink::mojom::SubAppsServiceResult>
    : public mojo::internal::EnumHashImpl<::blink::mojom::SubAppsServiceResult> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SubAppsServiceResult, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::blink::mojom::SubAppsServiceResult, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::blink::mojom::SubAppsServiceResult>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::blink::mojom::SubAppsServiceListResultDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::blink::mojom::SubAppsServiceListResultDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::blink::mojom::internal::SubAppsServiceListResult_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    mojo::internal::Serialize<::blink::mojom::SubAppsServiceResult>(
        Traits::code(input), &fragment->code);
    decltype(Traits::sub_app_ids(input)) in_sub_app_ids = Traits::sub_app_ids(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->sub_app_ids)::BaseType>
        sub_app_ids_fragment(fragment.message());
    const mojo::internal::ContainerValidateParams sub_app_ids_validate_params(
        0, false, new mojo::internal::ContainerValidateParams(0, false, nullptr));
    mojo::internal::Serialize<mojo::ArrayDataView<mojo::StringDataView>>(
        in_sub_app_ids, sub_app_ids_fragment, &sub_app_ids_validate_params);
    fragment->sub_app_ids.Set(
        sub_app_ids_fragment.is_null() ? nullptr : sub_app_ids_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->sub_app_ids.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null sub_app_ids in SubAppsServiceListResult struct");
  }

  static bool Deserialize(::blink::mojom::internal::SubAppsServiceListResult_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::blink::mojom::SubAppsServiceListResultDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace blink {
namespace mojom {

inline void SubAppsServiceListResultDataView::GetSubAppIdsDataView(
    mojo::ArrayDataView<mojo::StringDataView>* output) {
  auto pointer = data_->sub_app_ids.Get();
  *output = mojo::ArrayDataView<mojo::StringDataView>(pointer, message_);
}



}  // namespace mojom
}  // namespace blink

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct COMPONENT_EXPORT(MOJOM_SHARED_BLINK_COMMON_EXPORT) TraceFormatTraits<::blink::mojom::SubAppsServiceResult> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::blink::mojom::SubAppsServiceResult value);
};

} // namespace perfetto

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_SUBAPPS_SUB_APPS_SERVICE_MOJOM_SHARED_H_